
require "defines"

local opened = false
local copied = false

game.on_event(defines.events.on_tick, function(event)


    if game.player.opened == nil and opened == true then
        opened = false
    end
        
    if game.player.opened ~= nil and opened == false then
            
        if game.player.opened.name == "logistic-chest-requester"  then
                opened = true
        end    
    end
    
    if game.player.cursor_stack.valid_for_read == false then
        copied = false
    end
        
    if opened == true and game.player.cursor_stack.valid_for_read then
        local entity = game.player.opened
        
        if game.player.cursor_stack.name == "blueprint" and copied == false then
        --have bp in hand
            
            local table = game.player.cursor_stack.get_blueprint_entities()
            local entities = {}
            
            if table ~= nil then
                
                for k,v in ipairs(table) do
                    
                    if not entities[v.name] then
                        entities[v.name] = 1
                    else
                        entities[v.name] = entities[v.name] + 1
                    end
                end
               
                local i = 1

                for k, v in spairs(entities, function(t,a,b) return t[b] < t[a] end) do
                    
                    local itemstack = { name = k, count = v}

                    if i <= 10 then    
                        entity.set_request_slot(itemstack, i)
                    end

                    i = i + 1
                end
                copied = true -- bp mats were copied onto the requester slots
                game.player.print("Things were copied to requester slots.")
            end
        end
    end
end)

function spairs(t, order)
    -- collect the keys
    local keys = {}
    for k in pairs(t) do keys[#keys+1] = k end

    -- if order function given, sort by it by passing the table and keys a, b,
    -- otherwise just sort the keys 
    if order then
        table.sort(keys, function(a,b) return order(t, a, b) end)
    else
        table.sort(keys)
    end

    -- return the iterator function
    local i = 0
    return function()
        i = i + 1
        if keys[i] then
            return keys[i], t[keys[i]]
        end
    end
end